// MappingLib.cpp : Defines the initialization routines for the DLL.
//
#include <conio.h>

#include "stdafx.h"
#include "Mapping.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMappingLibApp

BEGIN_MESSAGE_MAP(CMappingLibApp, CWinApp)
END_MESSAGE_MAP()


CMappingLibApp::CMappingLibApp( )
{
	// TODO: add construction code here,
}


// CMappingLibApp initialization
BOOL CMappingLibApp::InitInstance()
{
	CWinApp::InitInstance();

	state_index = 1;
	return TRUE;
}

// my code from now on
void CMappingLibApp::setState( int index )
{
	state_index = index;
}
BOOL CMappingLibApp::initMapping( double inpts[5][2], double outpts[5][2] )
{
	for( int i=0; i<5; i++ ){
		for( int j=0; j<2; j++ ){
			inr[i][j] = inpts[i][j];
			outr[i][j] = outpts[i][j];
		}
	}
	return true;
}
void CMappingLibApp::reset( double ini[5], double outi[5] )
{
	this->cur_time = 0;
	switch( state_index ){
		case 1: box1( ini, outi ); break;
		case 2: box2( ini, outi ); break;
		case 3: box3( ini, outi ); break;
		default:
			for( int i=0; i<5; i++ )
				this->cache[i] = 0;
	}
}

//void CMappingLibApp::act( double ins[5], double spd[5], double outs[5], double outspd[5], long& time )
void CMappingLibApp::act( double ins[5], double outs[5], double time )
{
	switch( state_index ){
		case 1:	box1( ins, outs, time ); break;
		case 2:	box2( ins, outs, time ); break;
		case 3:	box3( ins, outs, time ); break;
		default:
			for( int i=0; i<5; i++ )
				outs[i] = ins[i];
	}
}

double CMappingLibApp::linearmap( double in, int ini, int outj )
{
	double slope;
	if( outj>=0 ){
		slope = ( outr[outj][1]-outr[outj][0] ) / (inr[ini][1]-inr[ini][0] );
		return (in-inr[ini][0])*slope + outr[outj][0];
	}
	slope = 1/abs(inr[ini][1]-inr[ini][0]);
	return ( in - min(inr[ini][0], inr[ini][1]) )*slope;
}

/*	box 1: use thumb to control and middle to indicate the current joint 
		thumb (4) control the current joint, which index is stored in cache[4];
		middle (3) control the next "current joint"; cache[3] stores the last movement of it for confirmation
	immediate reaction
*/
//void CMappingLibApp::box1( double ins[5], double spd[5], double outs[5], double outspd[5] )
void CMappingLibApp::box1( double ins[5], double outs[5], double time )
{
	if( time-cur_time < 0.01 )
		return;
	cur_time = time;

	int outj = (int)cache[2]; // current joint index: no other joint changes
	double o = linearmap( ins[4], 4, outj );

	int judge = 3;
	BOOL curl = ins[judge]>=( inr[judge][1]-(inr[judge][1]-inr[judge][0])/3.0 );
	BOOL ext =  ins[judge]<=( inr[judge][0]+(inr[judge][1]-inr[judge][0])/3.0 );
	if( (cache[3]==1) && curl ){ // mission complished
		outj += 1;
		if( outj>4 )
			outj = 0;
		cache[3] = 0;
//		printf( "joint changes to %f\n", outj );
		cache[2] = outj;
	}
	else if( (cache[3]==0) && ext ){ // extending the index finger, half way through
		cache[3] = 1;
	}

	if( abs(o-cache[4])<0.05 ) return;
	cache[4] = o;
	outs[outj] = o;
}
void CMappingLibApp::box1( double ini[5], double outi[5] )
{
	cache[4] = -1; // for thumb
	cache[3] = 0;	// for index status
	cache[2] = 0; // current active joint
}

/*	box 2: simultaneous movement of group of fingers control corresponding joint movement
		0(base): 4(thumb); 1: 2,1,0; 2: 2,1; 3: 3,(210); 4(grip): 1(ring)
	react only when time elapse long enough
*/	
//void CMappingLibApp::box2( double ins[5], double spd[5], double outs[5], double outspd[5] ) // action method
//void CMappingLibApp::box2( double ins[5], double outs[5], double time )
//{
//	double period = 0.003;
//	if( (time-cur_time) < period )
//		return;
//
//	static int lastmove=31;
//	int move, dir[5], half[5]; // 11111->43210
//	double dif = M_PI/36;
//	double cut = 1.0/period;
//	double spd, input;
//	move = 0;
//	for( int i=4; i>=0; i-- ){
//		move = move << 1;
//		input = ins[i]; //linearmap( ins[i], i, -1 );
//		spd = ( input-cache[i] )/(time-cur_time);
//		//if( abs(spd)>0.1 )
//			printf( "%f, ", spd );
//		//else
//		//	printf( "," );
//		if( abs(spd) >= cut )
//			move = move + 1;
//		dir[i] = (int)(spd>0);
//		half[i] = (int)((input+cache[i])>=(inr[i][0]+inr[i][1]));
//		cache[i] = input;
//	}
//	printf( "\n" );
//	cur_time = time;
//	double tmp = move;
//	move = move & lastmove;
//	lastmove = tmp;
//
//	if( move==0 ) // no movement, no change
//		return;
//	//printf( "%d, %d%d%d%d%d\n", move, dir[0],dir[1],dir[2],dir[3],dir[4] );
//	
//	int ind=-1, count, sim;
//	if( move==16 ){ // only thumb 10000
//		sim = dir[4];
//		count = 1;
//		if( (sim==count) || (sim==0) )
//			ind = 3;
//		sim = half[4];
//	}
//	else if( (move==8)&&((half[4]+half[0]+half[1]+half[2])==0) ){ // 01000
//		sim = dir[3];
//		count = 1;
//		if( (sim==count) || (sim==0) )
//			ind = 0;
//		sim = half[3];
//	}
//	else if( (move&7)==2 ){ // ??010
//		sim = dir[1];
//		count = 1;
//		ind = 4;
//	}
//	//else if( (move&17)==7 ){ //  ?111?
//	//	sim = dir[3] + dir[1]+dir[2];
//	//	count = 3;
//	//	if( (sim==count) || (sim==0) )
//	//		ind = 1;
//	//	sim = half[3]+half[1]+half[2];
//	//}
//	else if( (move&4)==4 ){ // ??110
//		sim = dir[2];
//		count = 1;
//		if( (sim==count) || (sim==0) )
//		{
//			if( half[3]==0 )
//				ind = 2;
//			else ind = 1;
//		}
//		sim = half[2];
//	}
//
//	if( ind==-1 ) // illegal combination
//		return;
//	if( sim==count ) // increment
//		outs[ind] = min( outr[ind][1], outs[ind]+dif );
//	else if( sim==0 ) // decrement
//		outs[ind] = max( outr[ind][0], outs[ind]-dif );
//	// else, not simutaneous move
//	return;
//}

void CMappingLibApp::box2( double ins[5], double outs[5], double time )
//box 2 : gesture based, finger curled or pointing out, finger(s) extended while others curled control the joint
//pinky as direction: curled -; pointing + ::	4(thumb):0(base); 3: 1; 3+4: 2; 2(4): 3; 2+3(4): 4(gripper)
{
	if( (time-cur_time) < 0.01 )
		return;
	
	double upper = 0.4, lower = 0.3;
	double dif = M_PI/270;

	int u, b; // 11111->43210; b: extended, u: curled
	double ul, bl;
	u = b = 0;
	for( int i=4; i>=0; i-- ){
		bl = (1-lower)*inr[i][0] + lower*inr[i][1];
		ul = upper*inr[i][0] + (1-upper)*inr[i][1];
		b = b << 1;
		u = u << 1;
		if( ins[i]<=bl )
			b = b + 1;
		else if( ins[i]>=ul )
			u = u + 1;
	}
	if( (u+b)!=31 ) return; // not all curled/extended

	int ind = -1;
	if( b==16 )
		ind = 0;
	else if( b==8 )
		ind = 1;
	else if( b==24 )
		ind = 2;
	else if( b==7 )
		ind = 3;
	else if( b==1 )
		ind = 4;

	if( ind==-1 ) return;
	if( cache[ind]==1 ){// increment
		outs[ind] += dif;
		if( outs[ind]>=outr[ind][1] ){
			cache[ind] = -1;
			outs[ind] = outr[ind][1];
		}
	}
	else{
		outs[ind] -= dif;
		if( outs[ind]<=outr[ind][0] ){
			cache[ind] = 1;
			outs[ind] = outr[ind][0];
		}
	}
}
void CMappingLibApp::box2( double ini[5], double outi[5] )
{
	for( int i=0; i<5; i++ )
		this->cache[i] = 1; //ini[i]; //linearmap( ini[i], i, -1 );
}

// box 3: x=thumb, y = index, z = middle, wrist = ring, and gripper = pinky
//void CMappingLibApp::box3( double ins[5], double spd[5], double outs[5], double outspd[5] ) // action method
void CMappingLibApp::box3( double ins[5], double outs[5], double time )
{
	if( time-cur_time < 0.01 )
		return;
	cur_time = time;
	outs[3] = linearmap( ins[1], 1, 3 );
	outs[4] = linearmap( ins[0], 0, 4 );

	// inverse kinematic : assuming l1 = l2 = 1.0/2;
	double x,y,z;
	// normalize to unit
	// first:
	x = linearmap( ins[4], 4, -1 ); //(ins[4]-inr[4][0])/(inr[4][1]-inr[4][0]);
	z = linearmap( ins[2], 2, -1 ); //(ins[2]-inr[2][0])/(inr[2][1]-inr[2][0]);
	y = linearmap( ins[3], 3, -1 ); //(ins[3]-(inr[3][0]+inr[3][1])/2.0)/(inr[3][1]-inr[3][0]);
	//y = 2*y - 1;

	// second: boundary for safety
	z = max( 0.3, z );

	// then, if (x,y,z) outside of the sphere, get it in
	double r = sqrt(x*x+y*y+z*z);
	if( r>1.0 ){
		r = 1.0/r;
		x *= r; y *= r; z *= r;
	}
	
	r = sqrt(x*x + y*y + z*z);
//	printf( "%f: %f %f %f\n", r, x, y, z );
	// calculate each angle now
	double x2 = sqrt(x*x+y*y);
	if( x==0 ){
		if( y>0 ) outs[0] = M_PI_2;
		else outs[0] = -M_PI_2;
	}
	else
		outs[0] = atan2( y, x );
	outs[0] = M_PI/2 + outs[0];

	if( x2==0 ){
		outs[1] = acos(z)+M_PI_2;
		outs[2] = 2*outs[1];
	}
	else{
		double tmp = acos(r);
		outs[1] = atan2( z,x2 ) + tmp;
//		if( outs[1]<M_PI_2)
			outs[2] = 2*tmp;
		//else{
		//	outs[1] = atan2( z,x2 ) - tmp; // + M_PI;
		//	outs[2] = 2*tmp + M_PI_2;
		//}
	}
}
void CMappingLibApp::box3( double ini[5], double outi[5] )// initialization method
{
}

/*********** export methods *****************/
__declspec(dllexport) void* acquireCtrlBox( int index )
{
	CMappingLibApp *pApp = new CMappingLibApp();
	pApp->InitInstance();
	pApp->setState( index );
	return (void*)pApp;
}
__declspec(dllexport) BOOL setCtrlBox( void* pm, double inrs[5][2], double outrs[5][2] )
{	
	if( !((CMappingLibApp*)pm)->initMapping( inrs, outrs ) ){
		printf( "Warning: the range is illegal. Control box initialization fails. \n" );
		return false;
	}
	return true;
}
__declspec(dllexport) void releaseCtrlBox( void* pm )
{
	delete ((CMappingLibApp*)pm);
}
__declspec(dllexport) void kickoffCtrlBox( void* pm, double ins[5], double outs[5] )
{
	((CMappingLibApp*)pm)->reset( ins, outs );
}
__declspec(dllexport) void passCtrlBox( void* pm, double ins[5], double outs[5], double time )
{
//	((CMappingLibApp*)pm)->act( ins, inspd, outs, outspd, time );
	((CMappingLibApp*)pm)->act( ins, outs, time );
}
